/* KeyFile.c generated by valac 0.34.4, the Vala compiler
 * generated from KeyFile.vala, do not modify */

/*
* Copyright (c) 2013-2017 elementary LLC. (http://launchpad.net/switchboard-plug-applications)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Julien Spautz <spautz.julien@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>


#define STARTUP_BACKEND_TYPE_KEY_FILE (startup_backend_key_file_get_type ())
#define STARTUP_BACKEND_KEY_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STARTUP_BACKEND_TYPE_KEY_FILE, StartupBackendKeyFile))
#define STARTUP_BACKEND_KEY_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), STARTUP_BACKEND_TYPE_KEY_FILE, StartupBackendKeyFileClass))
#define STARTUP_BACKEND_IS_KEY_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STARTUP_BACKEND_TYPE_KEY_FILE))
#define STARTUP_BACKEND_IS_KEY_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), STARTUP_BACKEND_TYPE_KEY_FILE))
#define STARTUP_BACKEND_KEY_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), STARTUP_BACKEND_TYPE_KEY_FILE, StartupBackendKeyFileClass))

typedef struct _StartupBackendKeyFile StartupBackendKeyFile;
typedef struct _StartupBackendKeyFileClass StartupBackendKeyFileClass;
typedef struct _StartupBackendKeyFilePrivate StartupBackendKeyFilePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define STARTUP_ENTITY_TYPE_APP_INFO (startup_entity_app_info_get_type ())
typedef struct _StartupEntityAppInfo StartupEntityAppInfo;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _StartupBackendKeyFile {
	GObject parent_instance;
	StartupBackendKeyFilePrivate * priv;
};

struct _StartupBackendKeyFileClass {
	GObjectClass parent_class;
};

struct _StartupBackendKeyFilePrivate {
	gchar* _path;
	GKeyFile* keyfile;
};

struct _StartupEntityAppInfo {
	gchar* name;
	gchar* comment;
	gchar* icon;
	gboolean active;
	gchar* path;
};


static gpointer startup_backend_key_file_parent_class = NULL;
static gchar** startup_backend_key_file_languages;
static gint startup_backend_key_file_languages_length1;
static gchar** startup_backend_key_file_languages = NULL;
static gint startup_backend_key_file_languages_length1 = 0;
static gint _startup_backend_key_file_languages_size_ = 0;
static gchar* startup_backend_key_file_preferred_language;
static gchar* startup_backend_key_file_preferred_language = NULL;

GType startup_backend_key_file_get_type (void) G_GNUC_CONST;
#define STARTUP_BACKEND_KEY_FILE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), STARTUP_BACKEND_TYPE_KEY_FILE, StartupBackendKeyFilePrivate))
enum  {
	STARTUP_BACKEND_KEY_FILE_DUMMY_PROPERTY,
	STARTUP_BACKEND_KEY_FILE_NAME,
	STARTUP_BACKEND_KEY_FILE_COMMAND,
	STARTUP_BACKEND_KEY_FILE_COMMENT,
	STARTUP_BACKEND_KEY_FILE_ICON,
	STARTUP_BACKEND_KEY_FILE_ACTIVE,
	STARTUP_BACKEND_KEY_FILE_SHOW,
	STARTUP_BACKEND_KEY_FILE_PATH
};
#define STARTUP_BACKEND_KEY_FILE_FALLBACK_ICON "application-default-icon"
#define STARTUP_BACKEND_KEY_FILE_KEY_NAME G_KEY_FILE_DESKTOP_KEY_NAME
#define STARTUP_BACKEND_KEY_FILE_KEY_COMMAND G_KEY_FILE_DESKTOP_KEY_EXEC
#define STARTUP_BACKEND_KEY_FILE_KEY_COMMENT G_KEY_FILE_DESKTOP_KEY_COMMENT
#define STARTUP_BACKEND_KEY_FILE_KEY_ICON G_KEY_FILE_DESKTOP_KEY_ICON
#define STARTUP_BACKEND_KEY_FILE_KEY_ACTIVE "X-GNOME-Autostart-enabled"
#define STARTUP_BACKEND_KEY_FILE_KEY_TYPE G_KEY_FILE_DESKTOP_KEY_TYPE
#define STARTUP_BACKEND_KEY_FILE_KEY_NO_DISPLAY G_KEY_FILE_DESKTOP_KEY_NO_DISPLAY
#define STARTUP_BACKEND_KEY_FILE_KEY_HIDDEN G_KEY_FILE_DESKTOP_KEY_HIDDEN
#define STARTUP_BACKEND_KEY_FILE_KEY_NOT_SHOW_IN G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN
#define STARTUP_BACKEND_KEY_FILE_KEY_ONLY_SHOW_IN G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN
StartupBackendKeyFile* startup_backend_key_file_new (const gchar* path);
StartupBackendKeyFile* startup_backend_key_file_construct (GType object_type, const gchar* path);
static void startup_backend_key_file_load_from_file (StartupBackendKeyFile* self);
StartupBackendKeyFile* startup_backend_key_file_new_from_command (const gchar* command);
StartupBackendKeyFile* startup_backend_key_file_construct_from_command (GType object_type, const gchar* command);
static gchar* startup_backend_key_file_create_path_for_custom_command (StartupBackendKeyFile* self);
void startup_backend_key_file_set_path (StartupBackendKeyFile* self, const gchar* value);
void startup_backend_key_file_set_name (StartupBackendKeyFile* self, const gchar* value);
void startup_backend_key_file_set_comment (StartupBackendKeyFile* self, const gchar* value);
void startup_backend_key_file_set_command (StartupBackendKeyFile* self, const gchar* value);
void startup_backend_key_file_set_icon (StartupBackendKeyFile* self, const gchar* value);
void startup_backend_key_file_set_active (StartupBackendKeyFile* self, gboolean value);
static void startup_backend_key_file_set_key (StartupBackendKeyFile* self, const gchar* key, const gchar* value);
void startup_backend_key_file_write_to_file (StartupBackendKeyFile* self);
gchar* startup_utils_get_user_startup_dir (void);
void startup_backend_key_file_delete_file (StartupBackendKeyFile* self);
const gchar* startup_backend_key_file_get_path (StartupBackendKeyFile* self);
gchar* startup_backend_key_file_get_name (StartupBackendKeyFile* self);
gchar* startup_backend_key_file_get_comment (StartupBackendKeyFile* self);
gchar* startup_backend_key_file_get_command (StartupBackendKeyFile* self);
gchar* startup_backend_key_file_get_icon (StartupBackendKeyFile* self);
gboolean startup_backend_key_file_get_active (StartupBackendKeyFile* self);
static void startup_backend_key_file_set_bool_key (StartupBackendKeyFile* self, const gchar* key, gboolean value);
static void startup_backend_key_file_keyfile_set_string (StartupBackendKeyFile* self, const gchar* key, const gchar* value);
static gboolean startup_backend_key_file_get_bool_key (StartupBackendKeyFile* self, const gchar* key);
static gchar* startup_backend_key_file_keyfile_get_string (StartupBackendKeyFile* self, const gchar* key);
static gboolean startup_backend_key_file_key_is_localized (StartupBackendKeyFile* self, const gchar* key);
static void startup_backend_key_file_keyfile_set_locale_string (StartupBackendKeyFile* self, const gchar* key, const gchar* value);
static gchar* startup_backend_key_file_get_key (StartupBackendKeyFile* self, const gchar* key);
static gchar* startup_backend_key_file_keyfile_get_locale_string (StartupBackendKeyFile* self, const gchar* key);
static gboolean startup_backend_key_file_show_in_environment (StartupBackendKeyFile* self);
void startup_backend_key_file_copy_to_local (StartupBackendKeyFile* self);
gchar* startup_backend_key_file_create_markup (StartupBackendKeyFile* self);
GType startup_entity_app_info_get_type (void) G_GNUC_CONST;
StartupEntityAppInfo* startup_entity_app_info_dup (const StartupEntityAppInfo* self);
void startup_entity_app_info_free (StartupEntityAppInfo* self);
void startup_entity_app_info_copy (const StartupEntityAppInfo* self, StartupEntityAppInfo* dest);
void startup_entity_app_info_destroy (StartupEntityAppInfo* self);
void startup_backend_key_file_create_app_info (StartupBackendKeyFile* self, StartupEntityAppInfo* result);
gboolean startup_backend_key_file_get_show (StartupBackendKeyFile* self);
static gchar** _vala_array_dup1 (gchar** self, int length);
static void startup_backend_key_file_finalize (GObject* obj);
static void _vala_startup_backend_key_file_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_startup_backend_key_file_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


StartupBackendKeyFile* startup_backend_key_file_construct (GType object_type, const gchar* path) {
	StartupBackendKeyFile * self = NULL;
	const gchar* _tmp0_ = NULL;
	GKeyFile* _tmp1_ = NULL;
#line 88 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 89 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = path;
#line 89 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	self = (StartupBackendKeyFile*) g_object_new (object_type, "path", _tmp0_, NULL);
#line 90 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = g_key_file_new ();
#line 90 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_key_file_unref0 (self->priv->keyfile);
#line 90 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	self->priv->keyfile = _tmp1_;
#line 91 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_load_from_file (self);
#line 88 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return self;
#line 179 "KeyFile.c"
}


StartupBackendKeyFile* startup_backend_key_file_new (const gchar* path) {
#line 88 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return startup_backend_key_file_construct (STARTUP_BACKEND_TYPE_KEY_FILE, path);
#line 186 "KeyFile.c"
}


StartupBackendKeyFile* startup_backend_key_file_construct_from_command (GType object_type, const gchar* command) {
	StartupBackendKeyFile * self = NULL;
	GKeyFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
#line 94 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (command != NULL, NULL);
#line 94 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	self = (StartupBackendKeyFile*) g_object_new (object_type, NULL);
#line 95 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = g_key_file_new ();
#line 95 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_key_file_unref0 (self->priv->keyfile);
#line 95 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	self->priv->keyfile = _tmp0_;
#line 97 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = startup_backend_key_file_create_path_for_custom_command (self);
#line 97 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2_ = _tmp1_;
#line 97 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_path (self, _tmp2_);
#line 97 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp2_);
#line 98 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp3_ = _ ("Custom Command");
#line 98 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_name (self, _tmp3_);
#line 99 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp4_ = command;
#line 99 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_comment (self, _tmp4_);
#line 100 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp5_ = command;
#line 100 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_command (self, _tmp5_);
#line 101 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_icon (self, STARTUP_BACKEND_KEY_FILE_FALLBACK_ICON);
#line 102 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_active (self, TRUE);
#line 104 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_key (self, STARTUP_BACKEND_KEY_FILE_KEY_TYPE, G_KEY_FILE_DESKTOP_TYPE_APPLICATION);
#line 106 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_write_to_file (self);
#line 94 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return self;
#line 238 "KeyFile.c"
}


StartupBackendKeyFile* startup_backend_key_file_new_from_command (const gchar* command) {
#line 94 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return startup_backend_key_file_construct_from_command (STARTUP_BACKEND_TYPE_KEY_FILE, command);
#line 245 "KeyFile.c"
}


static gchar* startup_backend_key_file_create_path_for_custom_command (StartupBackendKeyFile* self) {
	gchar* result = NULL;
	gchar* startup_dir = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp14_ = NULL;
#line 109 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_utils_get_user_startup_dir ();
#line 110 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_dir = _tmp0_;
#line 260 "KeyFile.c"
	{
		gint i = 0;
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		i = 0;
#line 265 "KeyFile.c"
		{
			gboolean _tmp1_ = FALSE;
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
			_tmp1_ = TRUE;
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
			while (TRUE) {
#line 272 "KeyFile.c"
				gint _tmp3_ = 0;
				gchar* filename = NULL;
				const gchar* _tmp4_ = NULL;
				gint _tmp5_ = 0;
				gchar* _tmp6_ = NULL;
				gchar* _tmp7_ = NULL;
				gchar* _tmp8_ = NULL;
				gchar* _tmp9_ = NULL;
				gchar* _tmp10_ = NULL;
				gchar* _tmp11_ = NULL;
				const gchar* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				if (!_tmp1_) {
#line 287 "KeyFile.c"
					gint _tmp2_ = 0;
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_tmp2_ = i;
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					i = _tmp2_ + 1;
#line 293 "KeyFile.c"
				}
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp1_ = FALSE;
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp3_ = i;
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				if (!(_tmp3_ < 100)) {
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					break;
#line 303 "KeyFile.c"
				}
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp4_ = startup_dir;
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp5_ = i;
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp6_ = g_strdup_printf ("%i", _tmp5_);
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp7_ = _tmp6_;
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp8_ = g_strconcat ("custom-command", _tmp7_, ".desktop", NULL);
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp9_ = _tmp8_;
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp10_ = g_build_filename (_tmp4_, _tmp9_, NULL);
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp11_ = _tmp10_;
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_g_free0 (_tmp9_);
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_g_free0 (_tmp7_);
#line 113 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				filename = _tmp11_;
#line 114 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp12_ = filename;
#line 114 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_tmp13_ = g_file_test (_tmp12_, G_FILE_TEST_EXISTS);
#line 114 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				if (_tmp13_ == FALSE) {
#line 115 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					result = filename;
#line 115 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_g_free0 (startup_dir);
#line 115 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					return result;
#line 339 "KeyFile.c"
				}
#line 112 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_g_free0 (filename);
#line 343 "KeyFile.c"
			}
		}
	}
#line 118 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp14_ = g_strdup ("");
#line 118 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp14_;
#line 118 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (startup_dir);
#line 118 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 355 "KeyFile.c"
}


void startup_backend_key_file_delete_file (StartupBackendKeyFile* self) {
	const gchar* _tmp0_ = NULL;
#line 121 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 122 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = self->priv->_path;
#line 122 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_remove (_tmp0_);
#line 367 "KeyFile.c"
}


static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
#line 37 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (self) {
#line 375 "KeyFile.c"
		gchar* _tmp0_ = NULL;
#line 38 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = _tmp0_;
#line 38 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 383 "KeyFile.c"
	} else {
		gchar* _tmp1_ = NULL;
#line 40 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = _tmp1_;
#line 40 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 392 "KeyFile.c"
	}
}


void startup_backend_key_file_write_to_file (StartupBackendKeyFile* self) {
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	GError * _inner_error_ = NULL;
#line 125 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 418 "KeyFile.c"
	{
		const gchar* _tmp0_ = NULL;
		GKeyFile* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
#line 127 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp0_ = self->priv->_path;
#line 127 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp1_ = self->priv->keyfile;
#line 127 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp2_ = g_key_file_to_data (_tmp1_, NULL, NULL);
#line 127 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp3_ = _tmp2_;
#line 127 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_file_set_contents (_tmp0_, _tmp3_, (gssize) -1, &_inner_error_);
#line 127 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (_tmp3_);
#line 127 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 438 "KeyFile.c"
			goto __catch5_g_error;
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 126 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		e = _inner_error_;
#line 126 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_inner_error_ = NULL;
#line 129 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp4_ = self->priv->_path;
#line 129 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_warning ("KeyFile.vala:129: Could not write to file %s", _tmp4_);
#line 130 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp5_ = e;
#line 130 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp6_ = _tmp5_->message;
#line 130 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_warning ("KeyFile.vala:130: %s", _tmp6_);
#line 126 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_error_free0 (e);
#line 465 "KeyFile.c"
	}
	__finally5:
#line 126 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 126 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 126 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_clear_error (&_inner_error_);
#line 126 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return;
#line 476 "KeyFile.c"
	}
#line 133 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp7_ = self->priv->_path;
#line 133 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_message ("KeyFile.vala:133: -- Saving to %s --", _tmp7_);
#line 134 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp8_ = startup_backend_key_file_get_name (self);
#line 134 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp9_ = _tmp8_;
#line 134 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp10_ = _tmp9_;
#line 134 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_message ("KeyFile.vala:134: Name:    %s", _tmp10_);
#line 134 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp10_);
#line 135 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp11_ = startup_backend_key_file_get_comment (self);
#line 135 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp12_ = _tmp11_;
#line 135 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp13_ = _tmp12_;
#line 135 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_message ("KeyFile.vala:135: Comment: %s", _tmp13_);
#line 135 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp13_);
#line 136 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp14_ = startup_backend_key_file_get_command (self);
#line 136 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp15_ = _tmp14_;
#line 136 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp16_ = _tmp15_;
#line 136 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_message ("KeyFile.vala:136: Command: %s", _tmp16_);
#line 136 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp16_);
#line 137 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp17_ = startup_backend_key_file_get_icon (self);
#line 137 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp18_ = _tmp17_;
#line 137 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp19_ = _tmp18_;
#line 137 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_message ("KeyFile.vala:137: Icon:    %s", _tmp19_);
#line 137 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp19_);
#line 138 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp20_ = startup_backend_key_file_get_active (self);
#line 138 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp21_ = _tmp20_;
#line 138 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp22_ = bool_to_string (_tmp21_);
#line 138 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp23_ = _tmp22_;
#line 138 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_message ("KeyFile.vala:138: Active:  %s", _tmp23_);
#line 138 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp23_);
#line 139 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_message ("KeyFile.vala:139: -- Done --");
#line 536 "KeyFile.c"
}


static void startup_backend_key_file_load_from_file (StartupBackendKeyFile* self) {
	GError * _inner_error_ = NULL;
#line 142 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 544 "KeyFile.c"
	{
		GKeyFile* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
#line 144 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp0_ = self->priv->keyfile;
#line 144 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp1_ = self->priv->_path;
#line 144 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_key_file_load_from_file (_tmp0_, _tmp1_, G_KEY_FILE_KEEP_TRANSLATIONS, &_inner_error_);
#line 144 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 556 "KeyFile.c"
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp2_ = NULL;
		GError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
#line 143 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		e = _inner_error_;
#line 143 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_inner_error_ = NULL;
#line 146 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp2_ = self->priv->_path;
#line 146 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_warning ("KeyFile.vala:146: Failed to load contents of file '%s'", _tmp2_);
#line 147 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp3_ = e;
#line 147 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp4_ = _tmp3_->message;
#line 147 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_warning ("KeyFile.vala:147: %s", _tmp4_);
#line 143 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_error_free0 (e);
#line 583 "KeyFile.c"
	}
	__finally6:
#line 143 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 143 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 143 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_clear_error (&_inner_error_);
#line 143 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return;
#line 594 "KeyFile.c"
	}
}


static void startup_backend_key_file_set_bool_key (StartupBackendKeyFile* self, const gchar* key, gboolean value) {
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* as_string = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
#line 151 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 151 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (key != NULL);
#line 152 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = value;
#line 152 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (_tmp1_) {
#line 152 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp0_ = "true";
#line 615 "KeyFile.c"
	} else {
#line 152 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp0_ = "false";
#line 619 "KeyFile.c"
	}
#line 152 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 152 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	as_string = _tmp2_;
#line 153 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp3_ = key;
#line 153 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_keyfile_set_string (self, _tmp3_, as_string);
#line 151 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (as_string);
#line 631 "KeyFile.c"
}


static gboolean startup_backend_key_file_get_bool_key (StartupBackendKeyFile* self, const gchar* key) {
	gboolean result = FALSE;
	gchar* as_string = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 156 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 157 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = key;
#line 157 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = startup_backend_key_file_keyfile_get_string (self, _tmp0_);
#line 157 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	as_string = _tmp1_;
#line 158 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = g_strcmp0 (as_string, "true") == 0;
#line 158 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (as_string);
#line 158 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 656 "KeyFile.c"
}


static void startup_backend_key_file_set_key (StartupBackendKeyFile* self, const gchar* key, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 161 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 161 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (key != NULL);
#line 161 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (value != NULL);
#line 162 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = key;
#line 162 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = startup_backend_key_file_key_is_localized (self, _tmp0_);
#line 162 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (_tmp1_) {
#line 675 "KeyFile.c"
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 163 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp2_ = key;
#line 163 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp3_ = value;
#line 163 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		startup_backend_key_file_keyfile_set_locale_string (self, _tmp2_, _tmp3_);
#line 684 "KeyFile.c"
	} else {
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
#line 165 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp4_ = key;
#line 165 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp5_ = value;
#line 165 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		startup_backend_key_file_keyfile_set_string (self, _tmp4_, _tmp5_);
#line 694 "KeyFile.c"
	}
}


static gchar* startup_backend_key_file_get_key (StartupBackendKeyFile* self, const gchar* key) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 168 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 168 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 169 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = key;
#line 169 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = startup_backend_key_file_key_is_localized (self, _tmp0_);
#line 169 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (_tmp1_) {
#line 713 "KeyFile.c"
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
#line 170 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp2_ = key;
#line 170 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp3_ = startup_backend_key_file_keyfile_get_locale_string (self, _tmp2_);
#line 170 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		result = _tmp3_;
#line 170 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return result;
#line 724 "KeyFile.c"
	} else {
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
#line 172 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp4_ = key;
#line 172 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp5_ = startup_backend_key_file_keyfile_get_string (self, _tmp4_);
#line 172 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		result = _tmp5_;
#line 172 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return result;
#line 736 "KeyFile.c"
	}
}


static gboolean startup_backend_key_file_key_is_localized (StartupBackendKeyFile* self, const gchar* key) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GQuark _tmp3_ = 0U;
#line 175 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 175 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 176 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = key;
#line 176 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = _tmp0_;
#line 176 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 176 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if ((_tmp3_ == g_quark_from_string (STARTUP_BACKEND_KEY_FILE_KEY_NAME)) || (_tmp3_ == g_quark_from_string (STARTUP_BACKEND_KEY_FILE_KEY_COMMENT))) {
#line 176 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		switch (0) {
#line 760 "KeyFile.c"
			default:
			{
#line 179 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				result = TRUE;
#line 179 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				return result;
#line 767 "KeyFile.c"
			}
		}
	} else if ((((((((_tmp3_ == g_quark_from_string (STARTUP_BACKEND_KEY_FILE_KEY_COMMAND)) || (_tmp3_ == g_quark_from_string (STARTUP_BACKEND_KEY_FILE_KEY_ICON))) || (_tmp3_ == g_quark_from_string (STARTUP_BACKEND_KEY_FILE_KEY_ACTIVE))) || (_tmp3_ == g_quark_from_string (STARTUP_BACKEND_KEY_FILE_KEY_NO_DISPLAY))) || (_tmp3_ == g_quark_from_string (STARTUP_BACKEND_KEY_FILE_KEY_TYPE))) || (_tmp3_ == g_quark_from_string (STARTUP_BACKEND_KEY_FILE_KEY_ONLY_SHOW_IN))) || (_tmp3_ == g_quark_from_string (STARTUP_BACKEND_KEY_FILE_KEY_NOT_SHOW_IN))) || (_tmp3_ == g_quark_from_string (STARTUP_BACKEND_KEY_FILE_KEY_HIDDEN))) {
#line 176 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		switch (0) {
#line 773 "KeyFile.c"
			default:
			{
#line 189 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				result = FALSE;
#line 189 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				return result;
#line 780 "KeyFile.c"
			}
		}
	} else {
#line 176 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		switch (0) {
#line 786 "KeyFile.c"
			default:
			{
#line 192 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				g_warn_if_reached ();
#line 193 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				result = FALSE;
#line 193 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				return result;
#line 795 "KeyFile.c"
			}
		}
	}
}


static void startup_backend_key_file_keyfile_set_string (StartupBackendKeyFile* self, const gchar* key, const gchar* value) {
	GKeyFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 197 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 197 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (key != NULL);
#line 197 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (value != NULL);
#line 198 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = self->priv->keyfile;
#line 198 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = key;
#line 198 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2_ = value;
#line 198 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_key_file_set_string (_tmp0_, G_KEY_FILE_DESKTOP_GROUP, _tmp1_, _tmp2_);
#line 820 "KeyFile.c"
}


static void startup_backend_key_file_keyfile_set_locale_string (StartupBackendKeyFile* self, const gchar* key, const gchar* value) {
	GKeyFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
#line 201 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 201 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (key != NULL);
#line 201 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (value != NULL);
#line 202 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = self->priv->keyfile;
#line 202 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = key;
#line 202 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2_ = startup_backend_key_file_preferred_language;
#line 202 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp3_ = value;
#line 202 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_key_file_set_locale_string (_tmp0_, G_KEY_FILE_DESKTOP_GROUP, _tmp1_, _tmp2_, _tmp3_);
#line 845 "KeyFile.c"
}


static gchar* startup_backend_key_file_keyfile_get_string (StartupBackendKeyFile* self, const gchar* key) {
	gchar* result = NULL;
	gchar* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 205 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 205 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 857 "KeyFile.c"
	{
		gchar* _tmp0_ = NULL;
		GKeyFile* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp1_ = self->priv->keyfile;
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp2_ = key;
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp3_ = g_key_file_get_string (_tmp1_, G_KEY_FILE_DESKTOP_GROUP, _tmp2_, &_inner_error_);
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp0_ = _tmp3_;
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 876 "KeyFile.c"
				goto __catch7_g_key_file_error;
			}
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
			g_clear_error (&_inner_error_);
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
			return NULL;
#line 885 "KeyFile.c"
		}
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp4_ = _tmp0_;
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp0_ = NULL;
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		result = _tmp4_;
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (_tmp0_);
#line 207 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return result;
#line 897 "KeyFile.c"
	}
	goto __finally7;
	__catch7_g_key_file_error:
	{
		GError* e = NULL;
#line 206 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		e = _inner_error_;
#line 206 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_inner_error_ = NULL;
#line 206 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_error_free0 (e);
#line 909 "KeyFile.c"
	}
	__finally7:
#line 206 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 206 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 206 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_clear_error (&_inner_error_);
#line 206 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return NULL;
#line 920 "KeyFile.c"
	}
#line 210 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp5_ = g_strdup ("");
#line 210 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp5_;
#line 210 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 928 "KeyFile.c"
}


static gchar* startup_backend_key_file_keyfile_get_locale_string (StartupBackendKeyFile* self, const gchar* key) {
	gchar* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
#line 213 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 213 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 214 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_languages;
#line 214 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0__length1 = startup_backend_key_file_languages_length1;
#line 946 "KeyFile.c"
	{
		gchar** lang_collection = NULL;
		gint lang_collection_length1 = 0;
		gint _lang_collection_size_ = 0;
		gint lang_it = 0;
#line 214 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		lang_collection = _tmp0_;
#line 214 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		lang_collection_length1 = _tmp0__length1;
#line 214 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		for (lang_it = 0; lang_it < _tmp0__length1; lang_it = lang_it + 1) {
#line 958 "KeyFile.c"
			gchar* _tmp1_ = NULL;
			gchar* lang = NULL;
#line 214 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
			_tmp1_ = g_strdup (lang_collection[lang_it]);
#line 214 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
			lang = _tmp1_;
#line 965 "KeyFile.c"
			{
				{
					gchar* _tmp2_ = NULL;
					GKeyFile* _tmp3_ = NULL;
					const gchar* _tmp4_ = NULL;
					const gchar* _tmp5_ = NULL;
					gchar* _tmp6_ = NULL;
					gchar* _tmp7_ = NULL;
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_tmp3_ = self->priv->keyfile;
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_tmp4_ = key;
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_tmp5_ = lang;
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_tmp6_ = g_key_file_get_locale_string (_tmp3_, G_KEY_FILE_DESKTOP_GROUP, _tmp4_, _tmp5_, &_inner_error_);
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_tmp2_ = _tmp6_;
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 988 "KeyFile.c"
							goto __catch8_g_key_file_error;
						}
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
						_g_free0 (lang);
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
						g_clear_error (&_inner_error_);
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
						return NULL;
#line 999 "KeyFile.c"
					}
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_tmp7_ = _tmp2_;
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_tmp2_ = NULL;
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					result = _tmp7_;
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_g_free0 (_tmp2_);
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_g_free0 (lang);
#line 216 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					return result;
#line 1013 "KeyFile.c"
				}
				goto __finally8;
				__catch8_g_key_file_error:
				{
					GError* e = NULL;
#line 215 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					e = _inner_error_;
#line 215 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_inner_error_ = NULL;
#line 215 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_g_error_free0 (e);
#line 1025 "KeyFile.c"
				}
				__finally8:
#line 215 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 215 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					_g_free0 (lang);
#line 215 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 215 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					g_clear_error (&_inner_error_);
#line 215 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
					return NULL;
#line 1038 "KeyFile.c"
				}
#line 214 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
				_g_free0 (lang);
#line 1042 "KeyFile.c"
			}
		}
	}
#line 220 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp8_ = g_strdup ("");
#line 220 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp8_;
#line 220 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1052 "KeyFile.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 1376 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1376 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1377 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1377 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1377 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1377 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 1072 "KeyFile.c"
}


static gboolean startup_backend_key_file_show_in_environment (StartupBackendKeyFile* self) {
	gboolean result = FALSE;
	gchar* only_show_in = NULL;
	gchar* _tmp0_ = NULL;
	gchar* not_show_in = NULL;
	gchar* _tmp1_ = NULL;
	gchar* session = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_ = NULL;
#line 223 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_get_key (self, STARTUP_BACKEND_KEY_FILE_KEY_ONLY_SHOW_IN);
#line 224 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	only_show_in = _tmp0_;
#line 225 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = startup_backend_key_file_get_key (self, STARTUP_BACKEND_KEY_FILE_KEY_NOT_SHOW_IN);
#line 225 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	not_show_in = _tmp1_;
#line 227 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2_ = g_getenv ("DESKTOP_SESSION");
#line 227 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 227 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	session = _tmp3_;
#line 229 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp4_ = only_show_in;
#line 229 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp5_ = session;
#line 229 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp6_ = string_contains (_tmp4_, _tmp5_);
#line 229 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (_tmp6_) {
#line 230 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		result = TRUE;
#line 230 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (session);
#line 230 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (not_show_in);
#line 230 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (only_show_in);
#line 230 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return result;
#line 1126 "KeyFile.c"
	}
#line 231 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp7_ = not_show_in;
#line 231 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp8_ = session;
#line 231 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp9_ = string_contains (_tmp7_, _tmp8_);
#line 231 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (_tmp9_) {
#line 232 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		result = FALSE;
#line 232 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (session);
#line 232 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (not_show_in);
#line 232 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (only_show_in);
#line 232 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return result;
#line 1146 "KeyFile.c"
	}
#line 234 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp10_ = only_show_in;
#line 234 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (g_strcmp0 (_tmp10_, "") == 0) {
#line 235 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		result = TRUE;
#line 235 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (session);
#line 235 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (not_show_in);
#line 235 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_g_free0 (only_show_in);
#line 235 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return result;
#line 1162 "KeyFile.c"
	}
#line 236 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = FALSE;
#line 236 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (session);
#line 236 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (not_show_in);
#line 236 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (only_show_in);
#line 236 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1174 "KeyFile.c"
}


void startup_backend_key_file_copy_to_local (StartupBackendKeyFile* self) {
	const gchar* _tmp0_ = NULL;
	gchar* basename = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* startup_dir = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
#line 239 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 239 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = self->priv->_path;
#line 239 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "path != null");
#line 240 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = self->priv->_path;
#line 240 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2_ = g_path_get_basename (_tmp1_);
#line 240 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	basename = _tmp2_;
#line 241 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp3_ = startup_utils_get_user_startup_dir ();
#line 241 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_dir = _tmp3_;
#line 242 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp4_ = g_build_filename (startup_dir, basename, NULL);
#line 242 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp5_ = _tmp4_;
#line 242 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_path (self, _tmp5_);
#line 242 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp5_);
#line 243 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_write_to_file (self);
#line 239 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (startup_dir);
#line 239 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (basename);
#line 1217 "KeyFile.c"
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
#line 1412 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1413 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = self;
#line 1413 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 1229 "KeyFile.c"
}


gchar* startup_backend_key_file_create_markup (StartupBackendKeyFile* self) {
	gchar* result = NULL;
	gchar* escaped_name = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* escaped_comment = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
#line 246 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 247 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_get_name (self);
#line 247 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = _tmp0_;
#line 247 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2_ = _tmp1_;
#line 247 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp3_ = g_markup_escape_text (_tmp2_, (gssize) -1);
#line 247 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp4_ = _tmp3_;
#line 247 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp2_);
#line 247 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	escaped_name = _tmp4_;
#line 248 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp5_ = startup_backend_key_file_get_comment (self);
#line 248 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp6_ = _tmp5_;
#line 248 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp7_ = _tmp6_;
#line 248 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp8_ = g_markup_escape_text (_tmp7_, (gssize) -1);
#line 248 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp9_ = _tmp8_;
#line 248 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp7_);
#line 248 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	escaped_comment = _tmp9_;
#line 250 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp10_ = string_to_string (escaped_name);
#line 250 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp11_ = string_to_string (escaped_comment);
#line 250 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp12_ = g_strconcat ("<span font_weight=\"bold\" size=\"large\">", _tmp10_, "</span>\n", _tmp11_, NULL);
#line 250 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp12_;
#line 250 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (escaped_comment);
#line 250 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (escaped_name);
#line 250 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1294 "KeyFile.c"
}


void startup_backend_key_file_create_app_info (StartupBackendKeyFile* self, StartupEntityAppInfo* result) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	StartupEntityAppInfo _tmp10_ = {0};
#line 253 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_get_name (self);
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = _tmp0_;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2_ = startup_backend_key_file_get_comment (self);
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp3_ = _tmp2_;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp4_ = startup_backend_key_file_get_icon (self);
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp5_ = _tmp4_;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp6_ = startup_backend_key_file_get_active (self);
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp7_ = _tmp6_;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp8_ = self->priv->_path;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	memset (&_tmp10_, 0, sizeof (StartupEntityAppInfo));
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp10_.name);
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp10_.name = _tmp1_;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp10_.comment);
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp10_.comment = _tmp3_;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp10_.icon);
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp10_.icon = _tmp5_;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp10_.active = _tmp7_;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp10_.path);
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp10_.path = _tmp9_;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	*result = _tmp10_;
#line 254 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return;
#line 1356 "KeyFile.c"
}


gchar* startup_backend_key_file_get_name (StartupBackendKeyFile* self) {
	gchar* result;
	gchar* _tmp0_ = NULL;
#line 43 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_get_key (self, STARTUP_BACKEND_KEY_FILE_KEY_NAME);
#line 43 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp0_;
#line 43 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1371 "KeyFile.c"
}


void startup_backend_key_file_set_name (StartupBackendKeyFile* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = value;
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_key (self, STARTUP_BACKEND_KEY_FILE_KEY_NAME, _tmp0_);
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_notify ((GObject *) self, "name");
#line 1385 "KeyFile.c"
}


gchar* startup_backend_key_file_get_command (StartupBackendKeyFile* self) {
	gchar* result;
	gchar* _tmp0_ = NULL;
#line 48 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_get_key (self, STARTUP_BACKEND_KEY_FILE_KEY_COMMAND);
#line 48 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp0_;
#line 48 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1400 "KeyFile.c"
}


void startup_backend_key_file_set_command (StartupBackendKeyFile* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = value;
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_key (self, STARTUP_BACKEND_KEY_FILE_KEY_COMMAND, _tmp0_);
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_notify ((GObject *) self, "command");
#line 1414 "KeyFile.c"
}


gchar* startup_backend_key_file_get_comment (StartupBackendKeyFile* self) {
	gchar* result;
	gchar* _tmp0_ = NULL;
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_get_key (self, STARTUP_BACKEND_KEY_FILE_KEY_COMMENT);
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp0_;
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1429 "KeyFile.c"
}


void startup_backend_key_file_set_comment (StartupBackendKeyFile* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
#line 54 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 54 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = value;
#line 54 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_key (self, STARTUP_BACKEND_KEY_FILE_KEY_COMMENT, _tmp0_);
#line 54 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_notify ((GObject *) self, "comment");
#line 1443 "KeyFile.c"
}


gchar* startup_backend_key_file_get_icon (StartupBackendKeyFile* self) {
	gchar* result;
	gchar* _tmp0_ = NULL;
#line 58 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_get_key (self, STARTUP_BACKEND_KEY_FILE_KEY_ICON);
#line 58 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp0_;
#line 58 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1458 "KeyFile.c"
}


void startup_backend_key_file_set_icon (StartupBackendKeyFile* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
#line 59 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 59 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = value;
#line 59 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_key (self, STARTUP_BACKEND_KEY_FILE_KEY_ICON, _tmp0_);
#line 59 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_notify ((GObject *) self, "icon");
#line 1472 "KeyFile.c"
}


gboolean startup_backend_key_file_get_active (StartupBackendKeyFile* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_get_bool_key (self, STARTUP_BACKEND_KEY_FILE_KEY_ACTIVE);
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp0_;
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1487 "KeyFile.c"
}


void startup_backend_key_file_set_active (StartupBackendKeyFile* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = value;
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_bool_key (self, STARTUP_BACKEND_KEY_FILE_KEY_ACTIVE, _tmp0_);
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_notify ((GObject *) self, "active");
#line 1501 "KeyFile.c"
}


gboolean startup_backend_key_file_get_show (StartupBackendKeyFile* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 68 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_get_bool_key (self, STARTUP_BACKEND_KEY_FILE_KEY_NO_DISPLAY);
#line 69 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (_tmp0_) {
#line 70 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		result = FALSE;
#line 70 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return result;
#line 1520 "KeyFile.c"
	}
#line 71 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = startup_backend_key_file_get_bool_key (self, STARTUP_BACKEND_KEY_FILE_KEY_HIDDEN);
#line 71 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	if (_tmp1_) {
#line 72 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		result = FALSE;
#line 72 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		return result;
#line 1530 "KeyFile.c"
	}
#line 73 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2_ = startup_backend_key_file_show_in_environment (self);
#line 73 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp2_;
#line 73 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1538 "KeyFile.c"
}


const gchar* startup_backend_key_file_get_path (StartupBackendKeyFile* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = self->priv->_path;
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = _tmp0_;
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1553 "KeyFile.c"
}


void startup_backend_key_file_set_path (StartupBackendKeyFile* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp0_ = value;
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (self->priv->_path);
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	self->priv->_path = _tmp1_;
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_notify ((GObject *) self, "path");
#line 1572 "KeyFile.c"
}


static gchar** _vala_array_dup1 (gchar** self, int length) {
	gchar** result;
	int i;
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	result = g_new0 (gchar*, length + 1);
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	for (i = 0; i < length; i++) {
#line 1583 "KeyFile.c"
		gchar* _tmp0_ = NULL;
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		_tmp0_ = g_strdup (self[i]);
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		result[i] = _tmp0_;
#line 1589 "KeyFile.c"
	}
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	return result;
#line 1593 "KeyFile.c"
}


static void startup_backend_key_file_class_init (StartupBackendKeyFileClass * klass) {
	gchar** _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_type_class_add_private (klass, sizeof (StartupBackendKeyFilePrivate));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_startup_backend_key_file_get_property;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_startup_backend_key_file_set_property;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	G_OBJECT_CLASS (klass)->finalize = startup_backend_key_file_finalize;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_BACKEND_KEY_FILE_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_BACKEND_KEY_FILE_COMMAND, g_param_spec_string ("command", "command", "command", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_BACKEND_KEY_FILE_COMMENT, g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_BACKEND_KEY_FILE_ICON, g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_BACKEND_KEY_FILE_ACTIVE, g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_BACKEND_KEY_FILE_SHOW, g_param_spec_boolean ("show", "show", "show", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_BACKEND_KEY_FILE_PATH, g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp1_ = _tmp0_ = g_get_language_names ();
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup1 (_tmp1_, _vala_array_length (_tmp0_)) : ((gpointer) _tmp1_);
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp2__length1 = _vala_array_length (_tmp0_);
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_languages = (_vala_array_free (startup_backend_key_file_languages, startup_backend_key_file_languages_length1, (GDestroyNotify) g_free), NULL);
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_languages = _tmp2_;
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_languages_length1 = _tmp2__length1;
#line 84 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_startup_backend_key_file_languages_size_ = startup_backend_key_file_languages_length1;
#line 85 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp3_ = startup_backend_key_file_languages;
#line 85 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp3__length1 = startup_backend_key_file_languages_length1;
#line 85 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp4_ = _tmp3_[0];
#line 85 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 85 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (startup_backend_key_file_preferred_language);
#line 85 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_preferred_language = _tmp5_;
#line 1656 "KeyFile.c"
}


static void startup_backend_key_file_instance_init (StartupBackendKeyFile * self) {
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	self->priv = STARTUP_BACKEND_KEY_FILE_GET_PRIVATE (self);
#line 1663 "KeyFile.c"
}


static void startup_backend_key_file_finalize (GObject* obj) {
	StartupBackendKeyFile * self;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_BACKEND_TYPE_KEY_FILE, StartupBackendKeyFile);
#line 77 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_free0 (self->priv->_path);
#line 79 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	_g_key_file_unref0 (self->priv->keyfile);
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	G_OBJECT_CLASS (startup_backend_key_file_parent_class)->finalize (obj);
#line 1677 "KeyFile.c"
}


/**
 * Stores information about an app found in it's .desktop file
 * and allows us to modify it.
 * http://standards.freedesktop.org/desktop-entry-spec/latest/index.html
 */
GType startup_backend_key_file_get_type (void) {
	static volatile gsize startup_backend_key_file_type_id__volatile = 0;
	if (g_once_init_enter (&startup_backend_key_file_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StartupBackendKeyFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_backend_key_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartupBackendKeyFile), 0, (GInstanceInitFunc) startup_backend_key_file_instance_init, NULL };
		GType startup_backend_key_file_type_id;
		startup_backend_key_file_type_id = g_type_register_static (G_TYPE_OBJECT, "StartupBackendKeyFile", &g_define_type_info, 0);
		g_once_init_leave (&startup_backend_key_file_type_id__volatile, startup_backend_key_file_type_id);
	}
	return startup_backend_key_file_type_id__volatile;
}


static void _vala_startup_backend_key_file_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	StartupBackendKeyFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, STARTUP_BACKEND_TYPE_KEY_FILE, StartupBackendKeyFile);
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	switch (property_id) {
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_NAME:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_value_take_string (value, startup_backend_key_file_get_name (self));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_COMMAND:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_value_take_string (value, startup_backend_key_file_get_command (self));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_COMMENT:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_value_take_string (value, startup_backend_key_file_get_comment (self));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_ICON:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_value_take_string (value, startup_backend_key_file_get_icon (self));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_ACTIVE:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_value_set_boolean (value, startup_backend_key_file_get_active (self));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_SHOW:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_value_set_boolean (value, startup_backend_key_file_get_show (self));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_PATH:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		g_value_set_string (value, startup_backend_key_file_get_path (self));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 1745 "KeyFile.c"
		default:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 1751 "KeyFile.c"
	}
}


static void _vala_startup_backend_key_file_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	StartupBackendKeyFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, STARTUP_BACKEND_TYPE_KEY_FILE, StartupBackendKeyFile);
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
	switch (property_id) {
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_NAME:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		startup_backend_key_file_set_name (self, g_value_get_string (value));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_COMMAND:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		startup_backend_key_file_set_command (self, g_value_get_string (value));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_COMMENT:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		startup_backend_key_file_set_comment (self, g_value_get_string (value));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_ICON:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		startup_backend_key_file_set_icon (self, g_value_get_string (value));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_ACTIVE:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		startup_backend_key_file_set_active (self, g_value_get_boolean (value));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_PATH:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		startup_backend_key_file_set_path (self, g_value_get_string (value));
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 1797 "KeyFile.c"
		default:
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/KeyFile.vala"
		break;
#line 1803 "KeyFile.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



