/* Monitor.c generated by valac 0.34.4, the Vala compiler
 * generated from Monitor.vala, do not modify */

/*
* Copyright (c) 2013-2017 elementary LLC. (http://launchpad.net/switchboard-plug-applications)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Julien Spautz <spautz.julien@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define STARTUP_PORT_TYPE_MONITOR (startup_port_monitor_get_type ())
#define STARTUP_PORT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STARTUP_PORT_TYPE_MONITOR, StartupPortMonitor))
#define STARTUP_PORT_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STARTUP_PORT_TYPE_MONITOR))
#define STARTUP_PORT_MONITOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), STARTUP_PORT_TYPE_MONITOR, StartupPortMonitorIface))

typedef struct _StartupPortMonitor StartupPortMonitor;
typedef struct _StartupPortMonitorIface StartupPortMonitorIface;

#define STARTUP_BACKEND_TYPE_MONITOR (startup_backend_monitor_get_type ())
#define STARTUP_BACKEND_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitor))
#define STARTUP_BACKEND_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitorClass))
#define STARTUP_BACKEND_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STARTUP_BACKEND_TYPE_MONITOR))
#define STARTUP_BACKEND_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), STARTUP_BACKEND_TYPE_MONITOR))
#define STARTUP_BACKEND_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitorClass))

typedef struct _StartupBackendMonitor StartupBackendMonitor;
typedef struct _StartupBackendMonitorClass StartupBackendMonitorClass;
typedef struct _StartupBackendMonitorPrivate StartupBackendMonitorPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _StartupPortMonitorIface {
	GTypeInterface parent_iface;
};

struct _StartupBackendMonitor {
	GObject parent_instance;
	StartupBackendMonitorPrivate * priv;
};

struct _StartupBackendMonitorClass {
	GObjectClass parent_class;
};

struct _StartupBackendMonitorPrivate {
	GFileMonitor* monitor;
};


static gpointer startup_backend_monitor_parent_class = NULL;
static StartupPortMonitorIface* startup_backend_monitor_startup_port_monitor_parent_iface = NULL;

GType startup_port_monitor_get_type (void) G_GNUC_CONST;
GType startup_backend_monitor_get_type (void) G_GNUC_CONST;
#define STARTUP_BACKEND_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitorPrivate))
enum  {
	STARTUP_BACKEND_MONITOR_DUMMY_PROPERTY
};
StartupBackendMonitor* startup_backend_monitor_new (void);
StartupBackendMonitor* startup_backend_monitor_construct (GType object_type);
static void startup_backend_monitor_setup (StartupBackendMonitor* self);
gchar* startup_utils_get_user_startup_dir (void);
static void startup_backend_monitor_on_change_occurred (StartupBackendMonitor* self, GFile* file, GFile* dest, GFileMonitorEvent event);
static void _startup_backend_monitor_on_change_occurred_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
gboolean startup_utils_is_desktop_file (const gchar* name);
static void startup_backend_monitor_finalize (GObject* obj);


static void startup_port_monitor_base_init (StartupPortMonitorIface * iface) {
#line 22 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	static gboolean initialized = FALSE;
#line 22 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	if (!initialized) {
#line 22 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		initialized = TRUE;
#line 22 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		g_signal_new ("file_created", STARTUP_PORT_TYPE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 22 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		g_signal_new ("file_deleted", STARTUP_PORT_TYPE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 22 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		g_signal_new ("file_edited", STARTUP_PORT_TYPE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 105 "Monitor.c"
	}
}


GType startup_port_monitor_get_type (void) {
	static volatile gsize startup_port_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&startup_port_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StartupPortMonitorIface), (GBaseInitFunc) startup_port_monitor_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType startup_port_monitor_type_id;
		startup_port_monitor_type_id = g_type_register_static (G_TYPE_INTERFACE, "StartupPortMonitor", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (startup_port_monitor_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&startup_port_monitor_type_id__volatile, startup_port_monitor_type_id);
	}
	return startup_port_monitor_type_id__volatile;
}


StartupBackendMonitor* startup_backend_monitor_construct (GType object_type) {
	StartupBackendMonitor * self = NULL;
#line 33 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	self = (StartupBackendMonitor*) g_object_new (object_type, NULL);
#line 34 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	startup_backend_monitor_setup (self);
#line 33 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	return self;
#line 131 "Monitor.c"
}


StartupBackendMonitor* startup_backend_monitor_new (void) {
#line 33 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	return startup_backend_monitor_construct (STARTUP_BACKEND_TYPE_MONITOR);
#line 138 "Monitor.c"
}


static void _startup_backend_monitor_on_change_occurred_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 42 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	startup_backend_monitor_on_change_occurred ((StartupBackendMonitor*) self, file, other_file, event_type);
#line 145 "Monitor.c"
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
#line 1412 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1413 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = self;
#line 1413 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 157 "Monitor.c"
}


static void startup_backend_monitor_setup (StartupBackendMonitor* self) {
	gchar* startup_dir = NULL;
	gchar* _tmp0_ = NULL;
	GFile* file = NULL;
	GFile* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 37 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 38 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_tmp0_ = startup_utils_get_user_startup_dir ();
#line 38 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	startup_dir = _tmp0_;
#line 39 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_tmp1_ = g_file_new_for_path (startup_dir);
#line 39 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	file = _tmp1_;
#line 177 "Monitor.c"
	{
		GFileMonitor* _tmp2_ = NULL;
		GFileMonitor* _tmp3_ = NULL;
		GFileMonitor* _tmp4_ = NULL;
		GFileMonitor* _tmp5_ = NULL;
#line 41 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp3_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
#line 41 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp2_ = _tmp3_;
#line 41 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 189 "Monitor.c"
			goto __catch10_g_error;
		}
#line 41 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp4_ = _tmp2_;
#line 41 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp2_ = NULL;
#line 41 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_g_object_unref0 (self->priv->monitor);
#line 41 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		self->priv->monitor = _tmp4_;
#line 42 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp5_ = self->priv->monitor;
#line 42 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		g_signal_connect_object (_tmp5_, "changed", (GCallback) _startup_backend_monitor_on_change_occurred_g_file_monitor_changed, self, 0);
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_g_object_unref0 (_tmp2_);
#line 206 "Monitor.c"
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		e = _inner_error_;
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_inner_error_ = NULL;
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp6_ = string_to_string (startup_dir);
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp7_ = g_strconcat ("Failed monitoring startup directory ", _tmp6_, NULL);
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp8_ = _tmp7_;
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		g_warning ("Monitor.vala:44: %s", _tmp8_);
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_g_free0 (_tmp8_);
#line 45 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp9_ = e;
#line 45 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp10_ = _tmp9_->message;
#line 45 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		g_warning ("Monitor.vala:45: %s", _tmp10_);
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_g_error_free0 (e);
#line 239 "Monitor.c"
	}
	__finally10:
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_g_object_unref0 (file);
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_g_free0 (startup_dir);
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		g_clear_error (&_inner_error_);
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		return;
#line 254 "Monitor.c"
	}
#line 37 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_g_object_unref0 (file);
#line 37 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_g_free0 (startup_dir);
#line 260 "Monitor.c"
}


static void startup_backend_monitor_on_change_occurred (StartupBackendMonitor* self, GFile* file, GFile* dest, GFileMonitorEvent event) {
	gchar* path = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GFileMonitorEvent _tmp4_ = 0;
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	g_return_if_fail (file != NULL);
#line 50 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_tmp0_ = file;
#line 50 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 50 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	path = _tmp1_;
#line 52 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_tmp2_ = path;
#line 52 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_tmp3_ = startup_utils_is_desktop_file (_tmp2_);
#line 52 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	if (_tmp3_ == FALSE) {
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_g_free0 (path);
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		return;
#line 291 "Monitor.c"
	}
#line 55 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_tmp4_ = event;
#line 55 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	if (_tmp4_ == G_FILE_MONITOR_EVENT_CREATED) {
#line 297 "Monitor.c"
		const gchar* _tmp5_ = NULL;
#line 56 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp5_ = path;
#line 56 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		g_signal_emit_by_name ((StartupPortMonitor*) self, "file-created", _tmp5_);
#line 303 "Monitor.c"
	} else {
		GFileMonitorEvent _tmp6_ = 0;
#line 57 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		_tmp6_ = event;
#line 57 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
		if (_tmp6_ == G_FILE_MONITOR_EVENT_DELETED) {
#line 310 "Monitor.c"
			const gchar* _tmp7_ = NULL;
#line 58 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
			_tmp7_ = path;
#line 58 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
			g_signal_emit_by_name ((StartupPortMonitor*) self, "file-deleted", _tmp7_);
#line 316 "Monitor.c"
		} else {
			GFileMonitorEvent _tmp8_ = 0;
#line 59 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
			_tmp8_ = event;
#line 59 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
			if (_tmp8_ == G_FILE_MONITOR_EVENT_CHANGED) {
#line 323 "Monitor.c"
				const gchar* _tmp9_ = NULL;
#line 60 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
				_tmp9_ = path;
#line 60 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
				g_signal_emit_by_name ((StartupPortMonitor*) self, "file-edited", _tmp9_);
#line 329 "Monitor.c"
			}
		}
	}
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_g_free0 (path);
#line 335 "Monitor.c"
}


static void startup_backend_monitor_class_init (StartupBackendMonitorClass * klass) {
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	startup_backend_monitor_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	g_type_class_add_private (klass, sizeof (StartupBackendMonitorPrivate));
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = startup_backend_monitor_finalize;
#line 346 "Monitor.c"
}


static void startup_backend_monitor_startup_port_monitor_interface_init (StartupPortMonitorIface * iface) {
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	startup_backend_monitor_startup_port_monitor_parent_iface = g_type_interface_peek_parent (iface);
#line 353 "Monitor.c"
}


static void startup_backend_monitor_instance_init (StartupBackendMonitor * self) {
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	self->priv = STARTUP_BACKEND_MONITOR_GET_PRIVATE (self);
#line 360 "Monitor.c"
}


static void startup_backend_monitor_finalize (GObject* obj) {
	StartupBackendMonitor * self;
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitor);
#line 31 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	_g_object_unref0 (self->priv->monitor);
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/Monitor.vala"
	G_OBJECT_CLASS (startup_backend_monitor_parent_class)->finalize (obj);
#line 372 "Monitor.c"
}


GType startup_backend_monitor_get_type (void) {
	static volatile gsize startup_backend_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&startup_backend_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StartupBackendMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_backend_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartupBackendMonitor), 0, (GInstanceInitFunc) startup_backend_monitor_instance_init, NULL };
		static const GInterfaceInfo startup_port_monitor_info = { (GInterfaceInitFunc) startup_backend_monitor_startup_port_monitor_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType startup_backend_monitor_type_id;
		startup_backend_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "StartupBackendMonitor", &g_define_type_info, 0);
		g_type_add_interface_static (startup_backend_monitor_type_id, STARTUP_PORT_TYPE_MONITOR, &startup_port_monitor_info);
		g_once_init_leave (&startup_backend_monitor_type_id__volatile, startup_backend_monitor_type_id);
	}
	return startup_backend_monitor_type_id__volatile;
}



